<!DOCTYPE html>
<!--

ENDLESS JUMPER

- penalty frequency: base on playing time, not on score.

- extra points for getting two or more bonuses in short time

- very short (~0.5s) invincibility after getting bonus?

- more/better sounds?
  https://sfxr.me/#34T6PksWAgVRmS8iJhsx9wak48q5P51EKMfbeim4ZzJXo1mDsueAdhMszXQZaur6RdV9AypQZa5ywsSAvbKYakGSeXvzi9QdCaWoZ4N43LuEsZnJTwauX5fnw

-->
<html>
    <head>
        <title>Endless jumper</title>
        <style>
.hud {
    position: absolute;
    z-index: 100;
    color: rgb(236, 147, 88);
    opacity: 0.9;
}

#gameOver {
    position: absolute;
    width: 100%;
    top: 0;

    z-index: 200;
    color: white;
    font-size: 30pt;
    opacity: 0.9;

    text-align: center;
    top: 50%;
    transform: translate(0, -50%);

    display: none;
}

h1, p {
    margin: 0;
}

#game {
    position: absolute;
    top: 0;
    left: 0;
    width: 800px;
    height: 600px;
    background-color: black;
}

#ceiling {
    position: absolute;
    left: 0;
    right: 0;
    height: 20px;
    bottom: 500px;
    background-color: lightgray;
}

#player {
    position: absolute;
    left: 250px;
    bottom: 0;
    width: 50px;
    height: 50px;
    border-radius: 50%;
    background-color: rgb(75, 101, 219);
}

.indicator {
    position: absolute;
    width: 4px;
    height: 4px;
    border-radius: 50%;
    background-color: white;
    display: none;
}

.object {
    position: absolute;
    left: 200px;
    bottom: 200px;
    width: 20px;
    height: 20px;
    border-radius: 50%;
}

.time-bonus {
    background-color: yellow;
}

.time-penalty {
    background-color: rgb(235, 66, 221);
}

.score-text {
    font-size: 10pt;
    color: white;
    position: absolute;
    z-index: 100;
}

        </style>
    </head>
    <body>
        <div id='game'>

            <div class='hud'>
                <h1>Endless jumper</h1>
                <p>Time: <span id='time'></span></p>
                <p>Score: <span id='score'></span></p>
                <h1 id='start'>START GAME</h1>
            </div>
            <div id='gameOver'>GAME OVER</div>

            <div id='ceiling'></div>
            <div id='player'></div>
        </div>

        <!-- howler.js -->
        <script src="https://cdnjs.cloudflare.com/ajax/libs/howler/2.2.3/howler.min.js" integrity="sha512-6+YN/9o9BWrk6wSfGxQGpt3EUK6XeHi6yeHV+TYD2GR0Sj/cggRpXr1BrAQf0as6XslxomMUxXp2vIl+fv0QRA==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

        <script>

const PLAYER_SIZE = 50;
const PLAYER_X = 250;
const PLAYER_SPEED_X = 5;
const OBJECT_SIZE = 20;
const CEILING_Y = 500;
const NUMBER_OF_INDICATORS = 10;
const TIME_INITIAL = 20;
const TIME_BONUS = 3;
const TIME_PENALTY = 5;
const JUMP_FORCE_MIN = 15;
const JUMP_FORCE_MAX = 50;
const JUMP_FORCE_STEP = 1.0;
const TICK_TIME = 1.0 / 60.0;

let elPlayer;

let elGame;

let elTime;

let elScore;

let timeLeft = TIME_INITIAL;

let score = 0;

let playerY = 0;

let playerSpeed = 0;

let playerDead = false;

let buttonDown = false;

let indicators = [];

let jumpForce = 0;

let timeBonuses = [];

let timePenalties = [];

let previousTimeStamp;

let soundGood, soundBad;

function scoreText(txt, x, y) {
    const el = document.createElement('div');
    el.classList.add('score-text');
    elGame.appendChild(el);
    el.style.left = `${x}px`;
    el.style.bottom = `${y}px`;
    el.innerText = txt;
    setTimeout( () => elGame.removeChild(el), 500 );
}

function frame(timestamp) {
    if (previousTimeStamp === undefined)
        previousTimeStamp = timestamp - 1000.0 / 60.0;
    let elapsed = timestamp - previousTimeStamp;
    previousTimeStamp = timestamp;

    while (elapsed > 16) {
        elapsed -= 16;
        tick();
    }

    if (!playerDead)
        requestAnimationFrame(frame);
}

function onObjectsCollidePlayer(objects, func) {
    for (b of objects) {
        // difference between centers
        const dx = Math.abs(b.x + OBJECT_SIZE/2 - (PLAYER_X + PLAYER_SIZE/2));
        const dy = Math.abs(b.y + OBJECT_SIZE/2 - (playerY + PLAYER_SIZE/2));
        if (dx + dy < 40) {
            func(b);
        }
    }
}

function checkAddObjects(objects, maxNumber, chance, className, min, max) {
    if (objects.length >= maxNumber)
        return;
    let urgency = ((maxNumber - objects.length) / maxNumber);
    let actualChance = urgency * chance;
    if (Math.random() < actualChance) {
        const el = document.createElement('div');
        const x = 800;
        const y = Math.random() * (max - min) + min;
        el.classList.add('object', className);
        el.style.bottom = `${y}px`;
        objects.push({ x, y, el, caught: false, remove: false });
        elGame.appendChild(el);
    }
}

function updateObjects(objects) {
    for (b of objects) {
        b.x -= PLAYER_SPEED_X;
        b.el.style.left = `${b.x}px`;
        if (b.x <= - 2 * PLAYER_SPEED_X || b.caught) {
            elGame.removeChild(b.el);
            b.remove = true;
        }
    }
}

function tick() {
    // Check if player collided with any objects
    onObjectsCollidePlayer(timeBonuses, (b) => {
        // Player gets extra time and score
        b.caught = true;
        timeLeft += TIME_BONUS;
        score++;
        elScore.innerText = score;
        scoreText(`+${TIME_BONUS}s`, b.x, b.y);
        soundGood.play();
    });
    // Check if player caught any time bonuses
    onObjectsCollidePlayer(timePenalties, (b) => {
        // Player get time penalty
        b.caught = true;
        timeLeft -= TIME_PENALTY;
        scoreText(`-${TIME_PENALTY}s`, b.x, b.y);
        soundBad.play();
    });

    // Advance time
    timeLeft -= TICK_TIME;
    elTime.innerText = Math.max(0, Math.floor(timeLeft));
    if (timeLeft < 0) {
        playerDead = true;
        elGameOver.style.display = 'block';
    }

    // Increase jump force while button is down
    if (buttonDown) {
        if (jumpForce === 0) {
            jumpForce = JUMP_FORCE_MIN;    // min force
        } else {
            jumpForce += JUMP_FORCE_STEP;
        }
        if (jumpForce > JUMP_FORCE_MAX)
            jumpForce = JUMP_FORCE_MAX;

        // Update indicators
        let indX = PLAYER_X + PLAYER_SIZE / 2;
        let indY = playerY + PLAYER_SIZE / 2;
        let indSpeed = jumpForce;
        for (let ind of indicators) {
            indX += PLAYER_SPEED_X;
            indY += indSpeed;
            indSpeed -= 1;
            ind.style.left = `${indX - 2}px`;
            ind.style.bottom = `${indY - 2}px`;
            ind.style.display = 'block';
        }
    } else {
        for (let ind of indicators) {
            ind.style.display = 'none';
        }
    }

    // Jump when button is released
    const playerOnGround = playerY < 0.01;
    if (playerOnGround && !buttonDown && jumpForce > 0) {
        /*if (jumpForce < JUMP_FORCE_MIN)
            jumpForce = JUMP_FORCE_MIN;*/
        playerSpeed = jumpForce;
        jumpForce = 0;
    }

    // Move player
    playerY += playerSpeed;
    if (playerY < 0)
        playerY = 0;
    elPlayer.style.bottom = `${playerY}px`;

    // Did player hit head?
    if (playerY + PLAYER_SIZE > CEILING_Y) {
        //playerDead = true;
        playerY = 2 * CEILING_Y - 2 * PLAYER_SIZE - playerY;
        playerSpeed = -playerSpeed;
    }
    if (playerY < 0) {
        playerY = -playerY;
        playerSpeed = -playerSpeed;
    }

    // Apply gravity to jumping player
    if (playerY > 0)
        playerSpeed -= 1;

    //console.log(playerY, playerSpeed);

    // Add time bonus (up to 3 onscreen)
    checkAddObjects(timeBonuses, 3, 0.06, 'time-bonus', 100, 400);
    let penaltyChance = 0.007 * (score / 10);
    checkAddObjects(timePenalties, Math.floor(score / 10), penaltyChance, 'time-penalty', 10, 400);

    // Update time bonus positions
    updateObjects(timeBonuses);
    updateObjects(timePenalties);

    // Get rid of bonuses that went offscreen or got caught
    timeBonuses = timeBonuses.filter(b => !b.remove);
    timePenalties = timePenalties.filter(b => !b.remove);
}

document.addEventListener('keydown', (e) => {
    if (e.code === 'Space') {
        buttonDown = true;
    }
})

document.addEventListener('keyup', (e) => {
    if (e.code === 'Space') {
        buttonDown = false;
    }
})

document.addEventListener('DOMContentLoaded', () => {
    elGame = document.querySelector('#game');
    elPlayer = document.querySelector('#player');
    elTime = document.querySelector('#time');
    elScore = document.querySelector('#score');
    elGameOver = document.querySelector('#gameOver');
    for (let i = 0; i < NUMBER_OF_INDICATORS; i++) {
        const ind = document.createElement('div');
        ind.classList.add('indicator');
        elGame.appendChild(ind);
        indicators.push(ind);
    }

    const elStart = document.querySelector('#start');
    elStart.addEventListener('click', () => {
        soundGood = new Howl({ src: [ 'good.mp3' ] } );
        soundBad = new Howl({ src: [ 'bad.mp3' ] });
        elStart.style.display = 'none';
        frame();
    });
});

        </script>
    </body>
</html>
